/* Copyright (C) 2003-2012 BOSSY Emmanuel.

This file is part of the SimSonic suite.

SimSonic is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SimSonic is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SimSonic.  If not, see <http://www.gnu.org/licenses/>. */

void CalculPMLCoinContraintes(PREC_GRILLE *Vi_I,PREC_GRILLE *Vi_J,PREC_GRILLE *Vi_K,
                              PREC_GRILLE *Vj_I,PREC_GRILLE *Vj_J,PREC_GRILLE *Vj_K,
                              PREC_GRILLE *Vk_I,PREC_GRILLE *Vk_J,PREC_GRILLE *Vk_K,
                              PREC_GRILLE *Tii_I,PREC_GRILLE *Tii_J,PREC_GRILLE *Tii_K,
                              PREC_GRILLE *Tjj_I,PREC_GRILLE *Tjj_J,PREC_GRILLE *Tjj_K,
                              PREC_GRILLE *Tkk_I,PREC_GRILLE *Tkk_J,PREC_GRILLE *Tkk_K,
                              PREC_GRILLE *Tij_I,PREC_GRILLE *Tij_J,
                              PREC_GRILLE *Tjk_J,PREC_GRILLE *Tjk_K,
                              PREC_GRILLE *Tki_K,PREC_GRILLE *Tki_I,
                              const char *TypeCoin)
{

    int i,j,k;
    double Cjkjk,Ckiki,Cijij;
    double SignI, SignJ, SignK;

    if (!strcmp(TypeCoin,"XpYpZp")||!strcmp(TypeCoin,"XpYpZm")||
            !strcmp(TypeCoin,"XpYmZp")||!strcmp(TypeCoin,"XpYmZm"))
        SignI = +1.0;
    else
        SignI = -1.0;

    if (!strcmp(TypeCoin,"XpYpZp")||!strcmp(TypeCoin,"XmYpZp")||
            !strcmp(TypeCoin,"XpYpZm")||!strcmp(TypeCoin,"XmYpZm"))
        SignJ = +1.0;
    else
        SignJ = -1.0;

    if (!strcmp(TypeCoin,"XpYpZp")||!strcmp(TypeCoin,"XmYpZp")||
            !strcmp(TypeCoin,"XpYmZp")||!strcmp(TypeCoin,"XmYmZp"))
        SignK = +1.0;
    else
        SignK = -1.0;

    /*Bloc Coin PML*/

#pragma omp parallel for private(j,k) schedule(guided)
    for (i=1; i<(W); i++)
    {
        for (j=1; j<(W); j++)
        {
            for (k=1; k<(W); k++)
            {

                Tii_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                        (1-DeltaT*AttenuationPML[2*i])*Tii_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]												+
                        DeltaTsurH*TableCii[Carte_Tampon[0]]*(
                            SignI*(	(Vi_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+ Vi_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+ Vi_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]	)
                                    -	(Vi_I[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(k)]+ Vi_J[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+ Vi_K[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(k)])	)	)	);

                Tii_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                        (1-DeltaT*AttenuationPML[2*j])*Tii_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]													+
                        DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                            SignJ*(	(Vj_I[(i)*(W)*(W+1)+(j)*(W+1)+(k)]	+ Vj_J[(i)*(W)*(W+1)+(j)*(W+1)+(k)]		+ Vj_K[(i)*(W)*(W+1)+(j)*(W+1)+(k)]	)
                                    -	(Vj_I[(i)*(W)*(W+1)+(j-1)*(W+1)+(k)]+ Vj_J[(i)*(W)*(W+1)+(j-1)*(W+1)+(k)]	+ Vj_K[(i)*(W)*(W+1)+(j-1)*(W+1)+(k)])	)	)	);

                Tii_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                        (1-DeltaT*AttenuationPML[2*k])*Tii_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]													+
                        DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                            SignK*(	(Vk_I[(i)*(W)*(W+1)+(j)*(W)+(k)]	+ Vk_J[(i)*(W)*(W+1)+(j)*(W)+(k)]		+ Vk_K[(i)*(W)*(W+1)+(j)*(W)+(k)]	)
                                    -	(Vk_I[(i)*(W)*(W+1)+(j)*(W)+(k-1)]+ Vk_J[(i)*(W)*(W+1)+(j)*(W)+(k-1)]	+ Vk_K[(i)*(W)*(W+1)+(j)*(W)+(k-1)])	)	)	);

                Tjj_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                        (1-DeltaT*AttenuationPML[2*i])*Tjj_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]												+
                        DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                            SignI*(	(Vi_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+ Vi_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+ Vi_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]	)
                                    -	(Vi_I[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(k)]+ Vi_J[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+ Vi_K[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(k)])	)	)	);

                Tjj_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                        (1-DeltaT*AttenuationPML[2*j])*Tjj_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]													+
                        DeltaTsurH*TableCjj[Carte_Tampon[0]]*(
                            SignJ*(	(Vj_I[(i)*(W)*(W+1)+(j)*(W+1)+(k)]	+ Vj_J[(i)*(W)*(W+1)+(j)*(W+1)+(k)]		+ Vj_K[(i)*(W)*(W+1)+(j)*(W+1)+(k)]	)
                                    -	(Vj_I[(i)*(W)*(W+1)+(j-1)*(W+1)+(k)]+ Vj_J[(i)*(W)*(W+1)+(j-1)*(W+1)+(k)]	+ Vj_K[(i)*(W)*(W+1)+(j-1)*(W+1)+(k)])	)	)	);

                Tjj_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                        (1-DeltaT*AttenuationPML[2*k])*Tjj_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]													+
                        DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                            SignK*(	(Vk_I[(i)*(W)*(W+1)+(j)*(W)+(k)]	+ Vk_J[(i)*(W)*(W+1)+(j)*(W)+(k)]		+ Vk_K[(i)*(W)*(W+1)+(j)*(W)+(k)]	)
                                    -	(Vk_I[(i)*(W)*(W+1)+(j)*(W)+(k-1)]+ Vk_J[(i)*(W)*(W+1)+(j)*(W)+(k-1)]	+ Vk_K[(i)*(W)*(W+1)+(j)*(W)+(k-1)])	)	)	);

                Tkk_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                        (1-DeltaT*AttenuationPML[2*i])*Tkk_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]												+
                        DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                            SignI*(	(Vi_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+ Vi_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+ Vi_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]	)
                                    -	(Vi_I[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(k)]+ Vi_J[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+ Vi_K[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(k)])	)	)	);

                Tkk_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                        (1-DeltaT*AttenuationPML[2*j])*Tkk_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]													+
                        DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                            SignJ*(	(Vj_I[(i)*(W)*(W+1)+(j)*(W+1)+(k)]	+ Vj_J[(i)*(W)*(W+1)+(j)*(W+1)+(k)]		+ Vj_K[(i)*(W)*(W+1)+(j)*(W+1)+(k)]	)
                                    -	(Vj_I[(i)*(W)*(W+1)+(j-1)*(W+1)+(k)]+ Vj_J[(i)*(W)*(W+1)+(j-1)*(W+1)+(k)]	+ Vj_K[(i)*(W)*(W+1)+(j-1)*(W+1)+(k)])	)	)	);

                Tkk_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                        (1-DeltaT*AttenuationPML[2*k])*Tkk_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]													+
                        DeltaTsurH*TableCkk[Carte_Tampon[0]]*(
                            SignK*(	(Vk_I[(i)*(W)*(W+1)+(j)*(W)+(k)]	+ Vk_J[(i)*(W)*(W+1)+(j)*(W)+(k)]		+ Vk_K[(i)*(W)*(W+1)+(j)*(W)+(k)]	)
                                    -	(Vk_I[(i)*(W)*(W+1)+(j)*(W)+(k-1)]+ Vk_J[(i)*(W)*(W+1)+(j)*(W)+(k-1)]	+ Vk_K[(i)*(W)*(W+1)+(j)*(W)+(k-1)])	)	)	);

            }
        }
    }
#pragma omp parallel for private(j,k,Cijij) schedule(guided)
    for (i=0; i<W; i++)
    {
        for (j=0; j<W; j++)
        {
            for (k=0; k<(W+1); k++)
            {


                Cijij=TableCijij[Carte_Tampon[0]];


                Tij_I[(i)*(W)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*	(
                        (1-DeltaT*AttenuationPML[1+2*i])*Tij_I[(i)*(W)*(W+1)+(j)*(W+1)+(k)]											+
                        DeltaTsurH*Cijij*(
                            SignI*(	(Vj_I[(i+1)*(W)*(W+1)+(j)*(W+1)+(k)]+Vj_J[(i+1)*(W)*(W+1)+(j)*(W+1)+(k)]+	Vj_K[(i+1)*(W)*(W+1)+(j)*(W+1)+(k)])
                                    -	(Vj_I[(i)*(W)*(W+1)+(j)*(W+1)+(k)]	+Vj_J[(i)*(W)*(W+1)+(j)*(W+1)+(k)]	+	Vj_K[(i)*(W)*(W+1)+(j)*(W+1)+(k)])	)	)	);

                Tij_J[(i)*(W)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*j])*	(
                        (1-DeltaT*AttenuationPML[1+2*j])*Tij_J[(i)*(W)*(W+1)+(j)*(W+1)+(k)]											+
                        DeltaTsurH*Cijij*(
                            SignJ*(	(Vi_I[(i)*(W+1)*(W+1)+(j+1)*(W+1)+(k)]	+Vi_J[(i)*(W+1)*(W+1)+(j+1)*(W+1)+(k)]	+Vi_K[(i)*(W+1)*(W+1)+(j+1)*(W+1)+(k)])
                                    -	(Vi_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+Vi_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+Vi_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)])	)	)	);
            }
        }
    }

#pragma omp parallel for private(j,k,Cjkjk) schedule(guided)
    for (i=0; i<(W+1); i++)
    {
        for (j=0; j<W; j++)
        {
            for (k=0; k<(W); k++)
            {


                Cjkjk=TableCjkjk[Carte_Tampon[0]];


                Tjk_J[(i)*(W)*(W)+(j)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*j])*	(
                                                     (1-DeltaT*AttenuationPML[1+2*j])*Tjk_J[(i)*(W)*(W)+(j)*(W)+(k)]											+
                                                     DeltaTsurH*Cjkjk*(
                                                             SignJ*(	(Vk_I[(i)*(W+1)*(W)+(j+1)*(W)+(k)]+Vk_J[(i)*(W+1)*(W)+(j+1)*(W)+(k)]+	Vk_K[(i)*(W+1)*(W)+(j+1)*(W)+(k)])
                                                                     -	(Vk_I[(i)*(W+1)*(W)+(j)*(W)+(k)]	+Vk_J[(i)*(W+1)*(W)+(j)*(W)+(k)]	+	Vk_K[(i)*(W+1)*(W)+(j)*(W)+(k)])	)	)	);

                Tjk_K[(i)*(W)*(W)+(j)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*k])*	(
                                                     (1-DeltaT*AttenuationPML[1+2*k])*Tjk_K[(i)*(W)*(W)+(j)*(W)+(k)]											+
                                                     DeltaTsurH*Cjkjk*(
                                                             SignK*(	(Vj_I[(i)*(W)*(W+1)+(j)*(W+1)+(k+1)]	+Vj_J[(i)*(W)*(W+1)+(j)*(W+1)+(k+1)]	+Vj_K[(i)*(W)*(W+1)+(j)*(W+1)+(k+1)])
                                                                     -	(Vj_I[(i)*(W)*(W+1)+(j)*(W+1)+(k)]		+Vj_J[(i)*(W)*(W+1)+(j)*(W+1)+(k)]		+Vj_K[(i)*(W)*(W+1)+(j)*(W+1)+(k)])	)	)	);
            }
        }
    }
#pragma omp parallel for private(j,k,Ckiki) schedule(guided)
    for (i=0; i<(W); i++)
    {
        for (j=0; j<(W+1); j++)
        {
            for (k=0; k<(W); k++)
            {


                Ckiki=TableCkiki[Carte_Tampon[0]];


                Tki_K[(i)*(W+1)*(W)+(j)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*k])*	(
                                                       (1-DeltaT*AttenuationPML[1+2*k])*Tki_K[(i)*(W+1)*(W)+(j)*(W)+(k)]											+
                                                       DeltaTsurH*Ckiki*(
                                                               SignK*(	(Vi_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k+1)]+Vi_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k+1)]+	Vi_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k+1)])
                                                                       -	(Vi_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+Vi_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+	Vi_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(k)])	)	)	);

                Tki_I[(i)*(W+1)*(W)+(j)*(W)+(k)] = 1./(1+DeltaT*AttenuationPML[1+2*i])*	(
                                                       (1-DeltaT*AttenuationPML[1+2*i])*Tki_I[(i)*(W+1)*(W)+(j)*(W)+(k)]											+
                                                       DeltaTsurH*Ckiki*(
                                                               SignI*(	(Vk_I[(i+1)*(W+1)*(W)+(j)*(W)+(k)]+Vk_J[(i+1)*(W+1)*(W)+(j)*(W)+(k)]+Vk_K[(i+1)*(W+1)*(W)+(j)*(W)+(k)])
                                                                       -	(Vk_I[(i)*(W+1)*(W)+(j)*(W)+(k)]	+Vk_J[(i)*(W+1)*(W)+(j)*(W)+(k)]	+Vk_K[(i)*(W+1)*(W)+(j)*(W)+(k)])	)	)	);
            }
        }
    }
    /*************************************************************************/
    /************************  Face Im  **************************************/
    /*************************************************************************/
#pragma omp parallel for private(k) schedule(guided)
    for (j=1; j<(W); j++)
    {
        for (k=1; k<(W); k++)
        {

            Tii_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Tii_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]												+
                    DeltaTsurH*TableCii[Carte_Tampon[0]]*(
                        SignI*(	(Vi_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+ Vi_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+ Vi_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]	)
                                -	(Vi_BufferCoinAreteI[j*(W+1)+k]		)	)	)	);

            Tii_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                    (1-DeltaT*AttenuationPML[2*j])*Tii_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]													+
                    DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                        SignJ*(	(Vj_I[(0)*(W)*(W+1)+(j)*(W+1)+(k)]	+ Vj_J[(0)*(W)*(W+1)+(j)*(W+1)+(k)]		+ Vj_K[(0)*(W)*(W+1)+(j)*(W+1)+(k)]	)
                                -	(Vj_I[(0)*(W)*(W+1)+(j-1)*(W+1)+(k)]+ Vj_J[(0)*(W)*(W+1)+(j-1)*(W+1)+(k)]	+ Vj_K[(0)*(W)*(W+1)+(j-1)*(W+1)+(k)])	)	)	);

            Tii_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                    (1-DeltaT*AttenuationPML[2*k])*Tii_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]													+
                    DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                        SignK*(	(Vk_I[(0)*(W)*(W+1)+(j)*(W)+(k)]	+ Vk_J[(0)*(W)*(W+1)+(j)*(W)+(k)]		+ Vk_K[(0)*(W)*(W+1)+(j)*(W)+(k)]	)
                                -	(Vk_I[(0)*(W)*(W+1)+(j)*(W)+(k-1)]+ Vk_J[(0)*(W)*(W+1)+(j)*(W)+(k-1)]	+ Vk_K[(0)*(W)*(W+1)+(j)*(W)+(k-1)])	)	)	);

            Tjj_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Tjj_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]												+
                    DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                        SignI*(	(Vi_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+ Vi_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+ Vi_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]	)
                                -	(Vi_BufferCoinAreteI[j*(W+1)+k])	)	)	);

            Tjj_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                    (1-DeltaT*AttenuationPML[2*j])*Tjj_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]													+
                    DeltaTsurH*TableCjj[Carte_Tampon[0]]*(
                        SignJ*(	(Vj_I[(0)*(W)*(W+1)+(j)*(W+1)+(k)]	+ Vj_J[(0)*(W)*(W+1)+(j)*(W+1)+(k)]		+ Vj_K[(0)*(W)*(W+1)+(j)*(W+1)+(k)]	)
                                -	(Vj_I[(0)*(W)*(W+1)+(j-1)*(W+1)+(k)]+ Vj_J[(0)*(W)*(W+1)+(j-1)*(W+1)+(k)]	+ Vj_K[(0)*(W)*(W+1)+(j-1)*(W+1)+(k)])	)	)	);

            Tjj_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                    (1-DeltaT*AttenuationPML[2*k])*Tjj_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]													+
                    DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                        SignK*(	(Vk_I[(0)*(W)*(W+1)+(j)*(W)+(k)]	+ Vk_J[(0)*(W)*(W+1)+(j)*(W)+(k)]		+ Vk_K[(0)*(W)*(W+1)+(j)*(W)+(k)]	)
                                -	(Vk_I[(0)*(W)*(W+1)+(j)*(W)+(k-1)]+ Vk_J[(0)*(W)*(W+1)+(j)*(W)+(k-1)]	+ Vk_K[(0)*(W)*(W+1)+(j)*(W)+(k-1)])	)	)	);

            Tkk_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Tkk_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]												+
                    DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                        SignI*(	(Vi_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]	+ Vi_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]		+ Vi_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]	)
                                -	(Vi_BufferCoinAreteI[j*(W+1)+k])	)	)	);

            Tkk_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                    (1-DeltaT*AttenuationPML[2*j])*Tkk_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]													+
                    DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                        SignJ*(	(Vj_I[(0)*(W)*(W+1)+(j)*(W+1)+(k)]	+ Vj_J[(0)*(W)*(W+1)+(j)*(W+1)+(k)]		+ Vj_K[(0)*(W)*(W+1)+(j)*(W+1)+(k)]	)
                                -	(Vj_I[(0)*(W)*(W+1)+(j-1)*(W+1)+(k)]+ Vj_J[(0)*(W)*(W+1)+(j-1)*(W+1)+(k)]	+ Vj_K[(0)*(W)*(W+1)+(j-1)*(W+1)+(k)])	)	)	);

            Tkk_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                    (1-DeltaT*AttenuationPML[2*k])*Tkk_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(k)]													+
                    DeltaTsurH*TableCkk[Carte_Tampon[0]]*(
                        SignK*(	(Vk_I[(0)*(W)*(W+1)+(j)*(W)+(k)]	+ Vk_J[(0)*(W)*(W+1)+(j)*(W)+(k)]		+ Vk_K[(0)*(W)*(W+1)+(j)*(W)+(k)]	)
                                -	(Vk_I[(0)*(W)*(W+1)+(j)*(W)+(k-1)]+ Vk_J[(0)*(W)*(W+1)+(j)*(W)+(k-1)]	+ Vk_K[(0)*(W)*(W+1)+(j)*(W)+(k-1)])	)	)	);

        }
    }
    /*************************************************************************/
    /************************  Face Jm  **************************************/
    /*************************************************************************/
#pragma omp parallel for private(k) schedule(guided)
    for (i=1; i<(W); i++)
    {
        for (k=1; k<(W); k++)
        {

            Tii_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                    (1-DeltaT*AttenuationPML[2*i])*Tii_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]												+
                    DeltaTsurH*TableCii[Carte_Tampon[0]]*(
                        SignI*(	(Vi_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]	+ Vi_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]		+ Vi_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]	)
                                -	(Vi_I[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(k)]+ Vi_J[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(k)]	+ Vi_K[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(k)])	)	)	);

            Tii_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Tii_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]													+
                    DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                        SignJ*(	(Vj_I[(i)*(W)*(W+1)+(0)*(W+1)+(k)]	+ Vj_J[(i)*(W)*(W+1)+(0)*(W+1)+(k)]		+ Vj_K[(i)*(W)*(W+1)+(0)*(W+1)+(k)]	)
                                -	(Vj_BufferCoinAreteJ[k*(W+1)+i])	)	)	);

            Tii_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                    (1-DeltaT*AttenuationPML[2*k])*Tii_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]													+
                    DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                        SignK*(	(Vk_I[(i)*(W)*(W+1)+(0)*(W)+(k)]	+ Vk_J[(i)*(W)*(W+1)+(0)*(W)+(k)]		+ Vk_K[(i)*(W)*(W+1)+(0)*(W)+(k)]	)
                                -	(Vk_I[(i)*(W)*(W+1)+(0)*(W)+(k-1)]+ Vk_J[(i)*(W)*(W+1)+(0)*(W)+(k-1)]	+ Vk_K[(i)*(W)*(W+1)+(0)*(W)+(k-1)])	)	)	);

            Tjj_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                    (1-DeltaT*AttenuationPML[2*i])*Tjj_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]												+
                    DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                        SignI*(	(Vi_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]	+ Vi_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]		+ Vi_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]	)
                                -	(Vi_I[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(k)]+ Vi_J[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(k)]	+ Vi_K[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(k)])	)	)	);

            Tjj_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Tjj_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]													+
                    DeltaTsurH*TableCjj[Carte_Tampon[0]]*(
                        SignJ*(	(Vj_I[(i)*(W)*(W+1)+(0)*(W+1)+(k)]	+ Vj_J[(i)*(W)*(W+1)+(0)*(W+1)+(k)]		+ Vj_K[(i)*(W)*(W+1)+(0)*(W+1)+(k)]	)
                                -	(Vj_BufferCoinAreteJ[k*(W+1)+i])	)	)	);

            Tjj_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                    (1-DeltaT*AttenuationPML[2*k])*Tjj_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]													+
                    DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                        SignK*(	(Vk_I[(i)*(W)*(W+1)+(0)*(W)+(k)]	+ Vk_J[(i)*(W)*(W+1)+(0)*(W)+(k)]		+ Vk_K[(i)*(W)*(W+1)+(0)*(W)+(k)]	)
                                -	(Vk_I[(i)*(W)*(W+1)+(0)*(W)+(k-1)]+ Vk_J[(i)*(W)*(W+1)+(0)*(W)+(k-1)]	+ Vk_K[(i)*(W)*(W+1)+(0)*(W)+(k-1)])	)	)	);


            Tkk_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                    (1-DeltaT*AttenuationPML[2*i])*Tkk_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]												+
                    DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                        SignI*(	(Vi_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]	+ Vi_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]		+ Vi_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]	)
                                -	(Vi_I[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(k)]+ Vi_J[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(k)]	+ Vi_K[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(k)])	)	)	);

            Tkk_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Tkk_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]													+
                    DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                        SignJ*(	(Vj_I[(i)*(W)*(W+1)+(0)*(W+1)+(k)]	+ Vj_J[(i)*(W)*(W+1)+(0)*(W+1)+(k)]		+ Vj_K[(i)*(W)*(W+1)+(0)*(W+1)+(k)]	)
                                -	(Vj_BufferCoinAreteJ[k*(W+1)+i])	)	)	);

            Tkk_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                    (1-DeltaT*AttenuationPML[2*k])*Tkk_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(k)]													+
                    DeltaTsurH*TableCkk[Carte_Tampon[0]]*(
                        SignK*(	(Vk_I[(i)*(W)*(W+1)+(0)*(W)+(k)]	+ Vk_J[(i)*(W)*(W+1)+(0)*(W)+(k)]		+ Vk_K[(i)*(W)*(W+1)+(0)*(W)+(k)]	)
                                -	(Vk_I[(i)*(W)*(W+1)+(0)*(W)+(k-1)]+ Vk_J[(i)*(W)*(W+1)+(0)*(W)+(k-1)]	+ Vk_K[(i)*(W)*(W+1)+(0)*(W)+(k-1)])	)	)	);

        }
    }

    /*************************************************************************/
    /************************  Face Km  **************************************/
    /*************************************************************************/
#pragma omp parallel for private(j) schedule(guided)
    for (i=1; i<(W); i++)
    {
        for (j=1; j<(W); j++)
        {

            Tii_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                    (1-DeltaT*AttenuationPML[2*i])*Tii_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]												+
                    DeltaTsurH*TableCii[Carte_Tampon[0]]*(
                        SignI*(	(Vi_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]	+ Vi_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]		+ Vi_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]	)
                                -	(Vi_I[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(0)]+ Vi_J[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(0)]	+ Vi_K[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(0)])	)	)	);

            Tii_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                    (1-DeltaT*AttenuationPML[2*j])*Tii_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]													+
                    DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                        SignJ*(	(Vj_I[(i)*(W)*(W+1)+(j)*(W+1)+(0)]	+ Vj_J[(i)*(W)*(W+1)+(j)*(W+1)+(0)]		+ Vj_K[(i)*(W)*(W+1)+(j)*(W+1)+(0)]	)
                                -	(Vj_I[(i)*(W)*(W+1)+(j-1)*(W+1)+(0)]+ Vj_J[(i)*(W)*(W+1)+(j-1)*(W+1)+(0)]	+ Vj_K[(i)*(W)*(W+1)+(j-1)*(W+1)+(0)])	)	)	);

            Tii_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Tii_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]													+
                    DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                        SignK*(	(Vk_I[(i)*(W)*(W+1)+(j)*(W)+(0)]	+ Vk_J[(i)*(W)*(W+1)+(j)*(W)+(0)]		+ Vk_K[(i)*(W)*(W+1)+(j)*(W)+(0)]	)
                                -	(Vk_BufferCoinAreteK[i*(W+1)+j])	)	)	);

            Tjj_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                    (1-DeltaT*AttenuationPML[2*i])*Tjj_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]												+
                    DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                        SignI*(	(Vi_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]	+ Vi_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]		+ Vi_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]	)
                                -	(Vi_I[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(0)]+ Vi_J[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(0)]	+ Vi_K[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(0)])	)	)	);

            Tjj_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                    (1-DeltaT*AttenuationPML[2*j])*Tjj_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]													+
                    DeltaTsurH*TableCjj[Carte_Tampon[0]]*(
                        SignJ*(	(Vj_I[(i)*(W)*(W+1)+(j)*(W+1)+(0)]	+ Vj_J[(i)*(W)*(W+1)+(j)*(W+1)+(0)]		+ Vj_K[(i)*(W)*(W+1)+(j)*(W+1)+(0)]	)
                                -	(Vj_I[(i)*(W)*(W+1)+(j-1)*(W+1)+(0)]+ Vj_J[(i)*(W)*(W+1)+(j-1)*(W+1)+(0)]	+ Vj_K[(i)*(W)*(W+1)+(j-1)*(W+1)+(0)])	)	)	);

            Tjj_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Tjj_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]													+
                    DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                        SignK*(	(Vk_I[(i)*(W)*(W+1)+(j)*(W)+(0)]	+ Vk_J[(i)*(W)*(W+1)+(j)*(W)+(0)]		+ Vk_K[(i)*(W)*(W+1)+(j)*(W)+(0)]	)
                                -	(Vk_BufferCoinAreteK[i*(W+1)+j])	)	)	);

            Tkk_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                    (1-DeltaT*AttenuationPML[2*i])*Tkk_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]												+
                    DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                        SignI*(	(Vi_I[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]	+ Vi_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]		+ Vi_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]	)
                                -	(Vi_I[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(0)]+ Vi_J[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(0)]	+ Vi_K[(i-1)*(W+1)*(W+1)+(j)*(W+1)+(0)])	)	)	);

            Tkk_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                    (1-DeltaT*AttenuationPML[2*j])*Tkk_J[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]													+
                    DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                        SignJ*(	(Vj_I[(i)*(W)*(W+1)+(j)*(W+1)+(0)]	+ Vj_J[(i)*(W)*(W+1)+(j)*(W+1)+(0)]		+ Vj_K[(i)*(W)*(W+1)+(j)*(W+1)+(0)]	)
                                -	(Vj_I[(i)*(W)*(W+1)+(j-1)*(W+1)+(0)]+ Vj_J[(i)*(W)*(W+1)+(j-1)*(W+1)+(0)]	+ Vj_K[(i)*(W)*(W+1)+(j-1)*(W+1)+(0)])	)	)	);

            Tkk_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                    (1-DeltaT*AttenuationPML[2*0])*Tkk_K[(i)*(W+1)*(W+1)+(j)*(W+1)+(0)]													+
                    DeltaTsurH*TableCkk[Carte_Tampon[0]]*(
                        SignK*(	(Vk_I[(i)*(W)*(W+1)+(j)*(W)+(0)]	+ Vk_J[(i)*(W)*(W+1)+(j)*(W)+(0)]		+ Vk_K[(i)*(W)*(W+1)+(j)*(W)+(0)]	)
                                -	(Vk_BufferCoinAreteK[i*(W+1)+j])	)	)	);

        }
    }
    /*************************************************************************/
    /************************  Arete Im/Jm ***********************************/
    /*************************************************************************/
#pragma omp parallel for schedule(guided)
    for (k=1; k<(W); k++)
    {

        Tii_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tii_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]												+
                DeltaTsurH*TableCii[Carte_Tampon[0]]*(
                    SignI*(	(Vi_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]	+ Vi_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]		+ Vi_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]	)
                            -	(Vi_BufferCoinAreteI[0*(W+1)+k]		)	)	)	);

        Tii_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tii_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]													+
                DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                    SignJ*(	(Vj_I[(0)*(W)*(W+1)+(0)*(W+1)+(k)]	+ Vj_J[(0)*(W)*(W+1)+(0)*(W+1)+(k)]		+ Vj_K[(0)*(W)*(W+1)+(0)*(W+1)+(k)]	)
                            -	(Vj_BufferCoinAreteJ[k*(W+1)+0])	)	)	);

        Tii_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                (1-DeltaT*AttenuationPML[2*k])*Tii_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]													+
                DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                    SignK*(	(Vk_I[(0)*(W)*(W+1)+(0)*(W)+(k)]	+ Vk_J[(0)*(W)*(W+1)+(0)*(W)+(k)]		+ Vk_K[(0)*(W)*(W+1)+(0)*(W)+(k)]	)
                            -	(Vk_I[(0)*(W)*(W+1)+(0)*(W)+(k-1)]+ Vk_J[(0)*(W)*(W+1)+(0)*(W)+(k-1)]	+ Vk_K[(0)*(W)*(W+1)+(0)*(W)+(k-1)])	)	)	);

        Tjj_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tjj_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]												+
                DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                    SignI*(	(Vi_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]	+ Vi_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]		+ Vi_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]	)
                            -	(Vi_BufferCoinAreteI[0*(W+1)+k])	)	)	);

        Tjj_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tjj_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]													+
                DeltaTsurH*TableCjj[Carte_Tampon[0]]*(
                    SignJ*(	(Vj_I[(0)*(W)*(W+1)+(0)*(W+1)+(k)]	+ Vj_J[(0)*(W)*(W+1)+(0)*(W+1)+(k)]		+ Vj_K[(0)*(W)*(W+1)+(0)*(W+1)+(k)]	)
                            -	(Vj_BufferCoinAreteJ[k*(W+1)+0])	)	)	);

        Tjj_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                (1-DeltaT*AttenuationPML[2*k])*Tjj_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]													+
                DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                    SignK*(	(Vk_I[(0)*(W)*(W+1)+(0)*(W)+(k)]	+ Vk_J[(0)*(W)*(W+1)+(0)*(W)+(k)]		+ Vk_K[(0)*(W)*(W+1)+(0)*(W)+(k)]	)
                            -	(Vk_I[(0)*(W)*(W+1)+(0)*(W)+(k-1)]+ Vk_J[(0)*(W)*(W+1)+(0)*(W)+(k-1)]	+ Vk_K[(0)*(W)*(W+1)+(0)*(W)+(k-1)])	)	)	);

        Tkk_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tkk_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]												+
                DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                    SignI*(	(Vi_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]	+ Vi_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]		+ Vi_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]	)
                            -	(Vi_BufferCoinAreteI[0*(W+1)+k])	)	)	);

        Tkk_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tkk_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]													+
                DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                    SignJ*(	(Vj_I[(0)*(W)*(W+1)+(0)*(W+1)+(k)]	+ Vj_J[(0)*(W)*(W+1)+(0)*(W+1)+(k)]		+ Vj_K[(0)*(W)*(W+1)+(0)*(W+1)+(k)]	)
                            -	(Vj_BufferCoinAreteJ[k*(W+1)+0])	)	)	);

        Tkk_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)] = 1./(1+DeltaT*AttenuationPML[2*k])*(
                (1-DeltaT*AttenuationPML[2*k])*Tkk_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(k)]													+
                DeltaTsurH*TableCkk[Carte_Tampon[0]]*(
                    SignK*(	(Vk_I[(0)*(W)*(W+1)+(0)*(W)+(k)]	+ Vk_J[(0)*(W)*(W+1)+(0)*(W)+(k)]		+ Vk_K[(0)*(W)*(W+1)+(0)*(W)+(k)]	)
                            -	(Vk_I[(0)*(W)*(W+1)+(0)*(W)+(k-1)]+ Vk_J[(0)*(W)*(W+1)+(0)*(W)+(k-1)]	+ Vk_K[(0)*(W)*(W+1)+(0)*(W)+(k-1)])	)	)	);

    }

    /*************************************************************************/
    /************************  Arete Jm/Km ***********************************/
    /*************************************************************************/
#pragma omp parallel for schedule(guided)
    for (i=1; i<(W); i++)
    {

        Tii_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                (1-DeltaT*AttenuationPML[2*i])*Tii_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]												+
                DeltaTsurH*TableCii[Carte_Tampon[0]]*(
                    SignI*(	(Vi_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]	+ Vi_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]		+ Vi_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]	)
                            -	(Vi_I[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(0)]+ Vi_J[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(0)]	+ Vi_K[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(0)])	)	)	);

        Tii_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tii_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]													+
                DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                    SignJ*(	(Vj_I[(i)*(W)*(W+1)+(0)*(W+1)+(0)]	+ Vj_J[(i)*(W)*(W+1)+(0)*(W+1)+(0)]		+ Vj_K[(i)*(W)*(W+1)+(0)*(W+1)+(0)]	)
                            -	(Vj_BufferCoinAreteJ[0*(W+1)+i])	)	)	);

        Tii_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tii_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]													+
                DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                    SignK*(	(Vk_I[(i)*(W)*(W+1)+(0)*(W)+(0)]	+ Vk_J[(i)*(W)*(W+1)+(0)*(W)+(0)]		+ Vk_K[(i)*(W)*(W+1)+(0)*(W)+(0)]	)
                            -	(Vk_BufferCoinAreteK[i*(W+1)+0])	)	)	);

        Tjj_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                (1-DeltaT*AttenuationPML[2*i])*Tjj_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]												+
                DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                    SignI*(	(Vi_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]	+ Vi_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]		+ Vi_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]	)
                            -	(Vi_I[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(0)]+ Vi_J[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(0)]	+ Vi_K[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(0)])	)	)	);

        Tjj_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tjj_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]													+
                DeltaTsurH*TableCjj[Carte_Tampon[0]]*(
                    SignJ*(	(Vj_I[(i)*(W)*(W+1)+(0)*(W+1)+(0)]	+ Vj_J[(i)*(W)*(W+1)+(0)*(W+1)+(0)]		+ Vj_K[(i)*(W)*(W+1)+(0)*(W+1)+(0)]	)
                            -	(Vj_BufferCoinAreteJ[0*(W+1)+i])	)	)	);

        Tjj_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tjj_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]													+
                DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                    SignK*(	(Vk_I[(i)*(W)*(W+1)+(0)*(W)+(0)]	+ Vk_J[(i)*(W)*(W+1)+(0)*(W)+(0)]		+ Vk_K[(i)*(W)*(W+1)+(0)*(W)+(0)]	)
                            -	(Vk_BufferCoinAreteK[i*(W+1)+0])	)	)	);

        Tkk_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*i])*(
                (1-DeltaT*AttenuationPML[2*i])*Tkk_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]												+
                DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                    SignI*(	(Vi_I[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]	+ Vi_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]		+ Vi_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]	)
                            -	(Vi_I[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(0)]+ Vi_J[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(0)]	+ Vi_K[(i-1)*(W+1)*(W+1)+(0)*(W+1)+(0)])	)	)	);

        Tkk_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tkk_J[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]													+
                DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                    SignJ*(	(Vj_I[(i)*(W)*(W+1)+(0)*(W+1)+(0)]	+ Vj_J[(i)*(W)*(W+1)+(0)*(W+1)+(0)]		+ Vj_K[(i)*(W)*(W+1)+(0)*(W+1)+(0)]	)
                            -	(Vj_BufferCoinAreteJ[0*(W+1)+i])	)	)	);

        Tkk_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tkk_K[(i)*(W+1)*(W+1)+(0)*(W+1)+(0)]													+
                DeltaTsurH*TableCkk[Carte_Tampon[0]]*(
                    SignK*(	(Vk_I[(i)*(W)*(W+1)+(0)*(W)+(0)]	+ Vk_J[(i)*(W)*(W+1)+(0)*(W)+(0)]		+ Vk_K[(i)*(W)*(W+1)+(0)*(W)+(0)]	)
                            -	(Vk_BufferCoinAreteK[i*(W+1)+0])	)	)	);

    }

    /*************************************************************************/
    /************************  Arete Km/Im ***********************************/
    /*************************************************************************/
#pragma omp parallel for schedule(guided)
    for (j=1; j<(W); j++)
    {

        Tii_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tii_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]												+
                DeltaTsurH*TableCii[Carte_Tampon[0]]*(
                    SignI*(	(Vi_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]	+ Vi_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]		+ Vi_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]	)
                            -	(Vi_BufferCoinAreteI[j*(W+1)+0])	)	)	);

        Tii_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                (1-DeltaT*AttenuationPML[2*j])*Tii_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]													+
                DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                    SignJ*(	(Vj_I[(0)*(W)*(W+1)+(j)*(W+1)+(0)]	+ Vj_J[(0)*(W)*(W+1)+(j)*(W+1)+(0)]		+ Vj_K[(0)*(W)*(W+1)+(j)*(W+1)+(0)]	)
                            -	(Vj_I[(0)*(W)*(W+1)+(j-1)*(W+1)+(0)]+ Vj_J[(0)*(W)*(W+1)+(j-1)*(W+1)+(0)]	+ Vj_K[(0)*(W)*(W+1)+(j-1)*(W+1)+(0)])	)	)	);

        Tii_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tii_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]													+
                DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                    SignK*(	(Vk_I[(0)*(W)*(W+1)+(j)*(W)+(0)]	+ Vk_J[(0)*(W)*(W+1)+(j)*(W)+(0)]		+ Vk_K[(0)*(W)*(W+1)+(j)*(W)+(0)]	)
                            -	(Vk_BufferCoinAreteK[0*(W+1)+j])	)	)	);

        Tjj_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tjj_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]												+
                DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                    SignI*(	(Vi_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]	+ Vi_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]		+ Vi_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]	)
                            -	(Vi_BufferCoinAreteI[j*(W+1)+0])	)	)	);

        Tjj_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                (1-DeltaT*AttenuationPML[2*j])*Tjj_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]													+
                DeltaTsurH*TableCjj[Carte_Tampon[0]]*(
                    SignJ*(	(Vj_I[(0)*(W)*(W+1)+(j)*(W+1)+(0)]	+ Vj_J[(0)*(W)*(W+1)+(j)*(W+1)+(0)]		+ Vj_K[(0)*(W)*(W+1)+(j)*(W+1)+(0)]	)
                            -	(Vj_I[(0)*(W)*(W+1)+(j-1)*(W+1)+(0)]+ Vj_J[(0)*(W)*(W+1)+(j-1)*(W+1)+(0)]	+ Vj_K[(0)*(W)*(W+1)+(j-1)*(W+1)+(0)])	)	)	);

        Tjj_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tjj_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]													+
                DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                    SignK*(	(Vk_I[(0)*(W)*(W+1)+(j)*(W)+(0)]	+ Vk_J[(0)*(W)*(W+1)+(j)*(W)+(0)]		+ Vk_K[(0)*(W)*(W+1)+(j)*(W)+(0)]	)
                            -	(Vk_BufferCoinAreteK[0*(W+1)+j])	)	)	);

        Tkk_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tkk_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]												+
                DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                    SignI*(	(Vi_I[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]	+ Vi_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]		+ Vi_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]	)
                            -	(Vi_BufferCoinAreteI[j*(W+1)+0])	)	)	);

        Tkk_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*j])*(
                (1-DeltaT*AttenuationPML[2*j])*Tkk_J[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]													+
                DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                    SignJ*(	(Vj_I[(0)*(W)*(W+1)+(j)*(W+1)+(0)]	+ Vj_J[(0)*(W)*(W+1)+(j)*(W+1)+(0)]		+ Vj_K[(0)*(W)*(W+1)+(j)*(W+1)+(0)]	)
                            -	(Vj_I[(0)*(W)*(W+1)+(j-1)*(W+1)+(0)]+ Vj_J[(0)*(W)*(W+1)+(j-1)*(W+1)+(0)]	+ Vj_K[(0)*(W)*(W+1)+(j-1)*(W+1)+(0)])	)	)	);

        Tkk_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
                (1-DeltaT*AttenuationPML[2*0])*Tkk_K[(0)*(W+1)*(W+1)+(j)*(W+1)+(0)]													+
                DeltaTsurH*TableCkk[Carte_Tampon[0]]*(
                    SignK*(	(Vk_I[(0)*(W)*(W+1)+(j)*(W)+(0)]	+ Vk_J[(0)*(W)*(W+1)+(j)*(W)+(0)]		+ Vk_K[(0)*(W)*(W+1)+(j)*(W)+(0)]	)
                            -	(Vk_BufferCoinAreteK[0*(W+1)+j])	)	)	);
    }
    /*************************************************************************/
    /************************  THE COIN **************************************/
    /*************************************************************************/

    Tii_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
            (1-DeltaT*AttenuationPML[2*0])*Tii_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]												+
            DeltaTsurH*TableCii[Carte_Tampon[0]]*(
                SignI*(	(Vi_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]	+ Vi_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]		+ Vi_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]	)
                        -	(Vi_BufferCoinAreteI[0*(W+1)+0])	)	)	);

    Tii_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
            (1-DeltaT*AttenuationPML[2*0])*Tii_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]													+
            DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                SignJ*(	(Vj_I[(0)*(W)*(W+1)+(0)*(W+1)+(0)]	+ Vj_J[(0)*(W)*(W+1)+(0)*(W+1)+(0)]		+ Vj_K[(0)*(W)*(W+1)+(0)*(W+1)+(0)]	)
                        -	(Vj_BufferCoinAreteJ[0])	)	)	);

    Tii_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
            (1-DeltaT*AttenuationPML[2*0])*Tii_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]													+
            DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                SignK*(	(Vk_I[(0)*(W)*(W+1)+(0)*(W)+(0)]	+ Vk_J[(0)*(W)*(W+1)+(0)*(W)+(0)]		+ Vk_K[(0)*(W)*(W+1)+(0)*(W)+(0)]	)
                        -	(Vk_BufferCoinAreteK[0*(W+1)+0])	)	)	);

    Tjj_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
            (1-DeltaT*AttenuationPML[2*0])*Tjj_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]												+
            DeltaTsurH*TableCij[Carte_Tampon[0]]*(
                SignI*(	(Vi_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]	+ Vi_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]		+ Vi_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]	)
                        -	(Vi_BufferCoinAreteI[0*(W+1)+0])	)	)	);

    Tjj_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
            (1-DeltaT*AttenuationPML[2*0])*Tjj_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]													+
            DeltaTsurH*TableCjj[Carte_Tampon[0]]*(
                SignJ*(	(Vj_I[(0)*(W)*(W+1)+(0)*(W+1)+(0)]	+ Vj_J[(0)*(W)*(W+1)+(0)*(W+1)+(0)]		+ Vj_K[(0)*(W)*(W+1)+(0)*(W+1)+(0)]	)
                        -	(Vj_BufferCoinAreteJ[0])	)	)	);

    Tjj_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
            (1-DeltaT*AttenuationPML[2*0])*Tjj_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]													+
            DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                SignK*(	(Vk_I[(0)*(W)*(W+1)+(0)*(W)+(0)]	+ Vk_J[(0)*(W)*(W+1)+(0)*(W)+(0)]		+ Vk_K[(0)*(W)*(W+1)+(0)*(W)+(0)]	)
                        -	(Vk_BufferCoinAreteK[0*(W+1)+0])	)	)	);

    Tkk_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
            (1-DeltaT*AttenuationPML[2*0])*Tkk_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]												+
            DeltaTsurH*TableCki[Carte_Tampon[0]]*(
                SignI*(	(Vi_I[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]	+ Vi_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]		+ Vi_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]	)
                        -	(Vi_BufferCoinAreteI[0*(W+1)+0])	)	)	);

    Tkk_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
            (1-DeltaT*AttenuationPML[2*0])*Tkk_J[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]													+
            DeltaTsurH*TableCjk[Carte_Tampon[0]]*(
                SignJ*(	(Vj_I[(0)*(W)*(W+1)+(0)*(W+1)+(0)]	+ Vj_J[(0)*(W)*(W+1)+(0)*(W+1)+(0)]		+ Vj_K[(0)*(W)*(W+1)+(0)*(W+1)+(0)]	)
                        -	(Vj_BufferCoinAreteJ[0])	)	)	);

    Tkk_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)] = 1./(1+DeltaT*AttenuationPML[2*0])*(
            (1-DeltaT*AttenuationPML[2*0])*Tkk_K[(0)*(W+1)*(W+1)+(0)*(W+1)+(0)]													+
            DeltaTsurH*TableCkk[Carte_Tampon[0]]*(
                SignK*(	(Vk_I[(0)*(W)*(W+1)+(0)*(W)+(0)]	+ Vk_J[(0)*(W)*(W+1)+(0)*(W)+(0)]		+ Vk_K[(0)*(W)*(W+1)+(0)*(W)+(0)]	)
                        -	(Vk_BufferCoinAreteK[0*(W+1)+0])	)	)	);

}

