/* Copyright (C) 2003-2012 BOSSY Emmanuel.

This file is part of the SimSonic suite.

SimSonic is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SimSonic is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SimSonic.  If not, see <http://www.gnu.org/licenses/>. */

#define PREC_CARTE  unsigned char
#define PREC_GRILLE  float

/****************************************************************************/
/*************************** Dimensions de la simulation ********************/
/****************************************************************************/

int X; /*// dimension selon x*/
int Y; /*// dimension selon y*/
int Z; /*// dimension selon z*/
int W; /*// Profondeur des PML;*/

/****************************************************************************/
/*************************** Grilles de calcul du Bloc Central **************/
/****************************************************************************/

PREC_GRILLE *Vx=NULL, *Vy=NULL, *Vz=NULL;
PREC_GRILLE *Ux=NULL, *Uy=NULL, *Uz=NULL;
PREC_GRILLE *Txx=NULL, *Tyy=NULL, *Tzz=NULL, *Txy=NULL, *Tyz=NULL, *Tzx=NULL;

/****************************************************************************/
/*************************** Grilles de Faces PML ***************************/
/****************************************************************************/

PREC_GRILLE *Vx_Xp_X=NULL, *Vx_Xp_YZ=NULL, *Vy_Xp_X=NULL, *Vy_Xp_YZ=NULL, *Vz_Xp_X=NULL, *Vz_Xp_YZ=NULL;
PREC_GRILLE *Txx_Xp_X=NULL, *Txx_Xp_YZ=NULL, *Tyy_Xp_X=NULL, *Tyy_Xp_YZ=NULL, *Tzz_Xp_X=NULL, *Tzz_Xp_YZ=NULL;
PREC_GRILLE *Txy_Xp_X=NULL, *Txy_Xp_YZ=NULL,*Tzx_Xp_X=NULL, *Tzx_Xp_YZ=NULL;
PREC_GRILLE *Tyz_Xp=NULL;

PREC_GRILLE *Vx_Xm_X=NULL, *Vx_Xm_YZ=NULL, *Vy_Xm_X=NULL, *Vy_Xm_YZ=NULL, *Vz_Xm_X=NULL, *Vz_Xm_YZ=NULL;
PREC_GRILLE *Txx_Xm_X=NULL, *Txx_Xm_YZ=NULL, *Tyy_Xm_X=NULL, *Tyy_Xm_YZ=NULL, *Tzz_Xm_X=NULL, *Tzz_Xm_YZ=NULL;
PREC_GRILLE *Txy_Xm_X=NULL, *Txy_Xm_YZ=NULL,*Tzx_Xm_X=NULL, *Tzx_Xm_YZ=NULL;
PREC_GRILLE *Tyz_Xm=NULL;

PREC_GRILLE *Vx_Yp_Y=NULL, *Vx_Yp_ZX=NULL, *Vy_Yp_Y=NULL, *Vy_Yp_ZX=NULL, *Vz_Yp_Y=NULL, *Vz_Yp_ZX=NULL;
PREC_GRILLE *Txx_Yp_Y=NULL, *Txx_Yp_ZX=NULL, *Tyy_Yp_Y=NULL, *Tyy_Yp_ZX=NULL, *Tzz_Yp_Y=NULL, *Tzz_Yp_ZX=NULL;
PREC_GRILLE *Txy_Yp_Y=NULL, *Txy_Yp_ZX=NULL,*Tyz_Yp_Y=NULL, *Tyz_Yp_ZX=NULL;
PREC_GRILLE *Tzx_Yp=NULL;

PREC_GRILLE *Vx_Ym_Y=NULL, *Vx_Ym_ZX=NULL, *Vy_Ym_Y=NULL, *Vy_Ym_ZX=NULL, *Vz_Ym_Y=NULL, *Vz_Ym_ZX=NULL;
PREC_GRILLE *Txx_Ym_Y=NULL, *Txx_Ym_ZX=NULL, *Tyy_Ym_Y=NULL, *Tyy_Ym_ZX=NULL, *Tzz_Ym_Y=NULL, *Tzz_Ym_ZX=NULL;
PREC_GRILLE *Txy_Ym_Y=NULL, *Txy_Ym_ZX=NULL,*Tyz_Ym_Y=NULL, *Tyz_Ym_ZX=NULL;
PREC_GRILLE *Tzx_Ym=NULL;

PREC_GRILLE *Vx_Zp_Z=NULL, *Vx_Zp_XY=NULL, *Vy_Zp_Z=NULL, *Vy_Zp_XY=NULL, *Vz_Zp_Z=NULL, *Vz_Zp_XY=NULL;
PREC_GRILLE *Txx_Zp_Z=NULL, *Txx_Zp_XY=NULL, *Tyy_Zp_Z=NULL, *Tyy_Zp_XY=NULL, *Tzz_Zp_Z=NULL, *Tzz_Zp_XY=NULL;
PREC_GRILLE *Tyz_Zp_Z=NULL, *Tyz_Zp_XY=NULL,*Tzx_Zp_Z=NULL, *Tzx_Zp_XY=NULL;
PREC_GRILLE *Txy_Zp=NULL;

PREC_GRILLE *Vx_Zm_Z=NULL, *Vx_Zm_XY=NULL, *Vy_Zm_Z=NULL, *Vy_Zm_XY=NULL, *Vz_Zm_Z=NULL, *Vz_Zm_XY=NULL;
PREC_GRILLE *Txx_Zm_Z=NULL, *Txx_Zm_XY=NULL, *Tyy_Zm_Z=NULL, *Tyy_Zm_XY=NULL, *Tzz_Zm_Z=NULL, *Tzz_Zm_XY=NULL;
PREC_GRILLE *Tyz_Zm_Z=NULL, *Tyz_Zm_XY=NULL,*Tzx_Zm_Z=NULL, *Tzx_Zm_XY=NULL;
PREC_GRILLE *Txy_Zm=NULL;

/****************************************************************************/
/*************************** Grilles d'Aretes PML ***************************/
/****************************************************************************/

PREC_GRILLE *Vx_XpYp_X=NULL, *Vx_XpYp_Y=NULL, *Vx_XpYp_Z=NULL;
PREC_GRILLE *Vy_XpYp_X=NULL, *Vy_XpYp_Y=NULL, *Vy_XpYp_Z=NULL;
PREC_GRILLE *Vz_XpYp_X=NULL, *Vz_XpYp_Y=NULL, *Vz_XpYp_Z=NULL;
PREC_GRILLE *Txx_XpYp_X=NULL, *Txx_XpYp_Y=NULL, *Txx_XpYp_Z=NULL;
PREC_GRILLE *Tyy_XpYp_X=NULL, *Tyy_XpYp_Y=NULL, *Tyy_XpYp_Z=NULL;
PREC_GRILLE *Tzz_XpYp_X=NULL, *Tzz_XpYp_Y=NULL, *Tzz_XpYp_Z=NULL;
PREC_GRILLE *Txy_XpYp_X=NULL, *Txy_XpYp_Y=NULL;
PREC_GRILLE *Tyz_XpYp_Y=NULL, *Tyz_XpYp_Z=NULL;
PREC_GRILLE *Tzx_XpYp_Z=NULL, *Tzx_XpYp_X=NULL;

PREC_GRILLE *Vx_XpYm_X=NULL, *Vx_XpYm_Y=NULL, *Vx_XpYm_Z=NULL;
PREC_GRILLE *Vy_XpYm_X=NULL, *Vy_XpYm_Y=NULL, *Vy_XpYm_Z=NULL;
PREC_GRILLE *Vz_XpYm_X=NULL, *Vz_XpYm_Y=NULL, *Vz_XpYm_Z=NULL;
PREC_GRILLE *Txx_XpYm_X=NULL, *Txx_XpYm_Y=NULL, *Txx_XpYm_Z=NULL;
PREC_GRILLE *Tyy_XpYm_X=NULL, *Tyy_XpYm_Y=NULL, *Tyy_XpYm_Z=NULL;
PREC_GRILLE *Tzz_XpYm_X=NULL, *Tzz_XpYm_Y=NULL, *Tzz_XpYm_Z=NULL;
PREC_GRILLE *Txy_XpYm_X=NULL, *Txy_XpYm_Y=NULL;
PREC_GRILLE *Tyz_XpYm_Y=NULL, *Tyz_XpYm_Z=NULL;
PREC_GRILLE *Tzx_XpYm_Z=NULL, *Tzx_XpYm_X=NULL;

PREC_GRILLE *Vx_XmYp_X=NULL, *Vx_XmYp_Y=NULL, *Vx_XmYp_Z=NULL;
PREC_GRILLE *Vy_XmYp_X=NULL, *Vy_XmYp_Y=NULL, *Vy_XmYp_Z=NULL;
PREC_GRILLE *Vz_XmYp_X=NULL, *Vz_XmYp_Y=NULL, *Vz_XmYp_Z=NULL;
PREC_GRILLE *Txx_XmYp_X=NULL, *Txx_XmYp_Y=NULL, *Txx_XmYp_Z=NULL;
PREC_GRILLE *Tyy_XmYp_X=NULL, *Tyy_XmYp_Y=NULL, *Tyy_XmYp_Z=NULL;
PREC_GRILLE *Tzz_XmYp_X=NULL, *Tzz_XmYp_Y=NULL, *Tzz_XmYp_Z=NULL;
PREC_GRILLE *Txy_XmYp_X=NULL, *Txy_XmYp_Y=NULL;
PREC_GRILLE *Tyz_XmYp_Y=NULL, *Tyz_XmYp_Z=NULL;
PREC_GRILLE *Tzx_XmYp_Z=NULL, *Tzx_XmYp_X=NULL;

PREC_GRILLE *Vx_XmYm_X=NULL, *Vx_XmYm_Y=NULL, *Vx_XmYm_Z=NULL;
PREC_GRILLE *Vy_XmYm_X=NULL, *Vy_XmYm_Y=NULL, *Vy_XmYm_Z=NULL;
PREC_GRILLE *Vz_XmYm_X=NULL, *Vz_XmYm_Y=NULL, *Vz_XmYm_Z=NULL;
PREC_GRILLE *Txx_XmYm_X=NULL, *Txx_XmYm_Y=NULL, *Txx_XmYm_Z=NULL;
PREC_GRILLE *Tyy_XmYm_X=NULL, *Tyy_XmYm_Y=NULL, *Tyy_XmYm_Z=NULL;
PREC_GRILLE *Tzz_XmYm_X=NULL, *Tzz_XmYm_Y=NULL, *Tzz_XmYm_Z=NULL;
PREC_GRILLE *Txy_XmYm_X=NULL, *Txy_XmYm_Y=NULL;
PREC_GRILLE *Tyz_XmYm_Y=NULL, *Tyz_XmYm_Z=NULL;
PREC_GRILLE *Tzx_XmYm_Z=NULL, *Tzx_XmYm_X=NULL;

PREC_GRILLE *Vx_YpZp_X=NULL, *Vx_YpZp_Y=NULL, *Vx_YpZp_Z=NULL;
PREC_GRILLE *Vy_YpZp_X=NULL, *Vy_YpZp_Y=NULL, *Vy_YpZp_Z=NULL;
PREC_GRILLE *Vz_YpZp_X=NULL, *Vz_YpZp_Y=NULL, *Vz_YpZp_Z=NULL;
PREC_GRILLE *Txx_YpZp_X=NULL, *Txx_YpZp_Y=NULL, *Txx_YpZp_Z=NULL;
PREC_GRILLE *Tyy_YpZp_X=NULL, *Tyy_YpZp_Y=NULL, *Tyy_YpZp_Z=NULL;
PREC_GRILLE *Tzz_YpZp_X=NULL, *Tzz_YpZp_Y=NULL, *Tzz_YpZp_Z=NULL;
PREC_GRILLE *Txy_YpZp_X=NULL, *Txy_YpZp_Y=NULL;
PREC_GRILLE *Tyz_YpZp_Y=NULL, *Tyz_YpZp_Z=NULL;
PREC_GRILLE *Tzx_YpZp_Z=NULL, *Tzx_YpZp_X=NULL;

PREC_GRILLE *Vx_YpZm_X=NULL, *Vx_YpZm_Y=NULL, *Vx_YpZm_Z=NULL;
PREC_GRILLE *Vy_YpZm_X=NULL, *Vy_YpZm_Y=NULL, *Vy_YpZm_Z=NULL;
PREC_GRILLE *Vz_YpZm_X=NULL, *Vz_YpZm_Y=NULL, *Vz_YpZm_Z=NULL;
PREC_GRILLE *Txx_YpZm_X=NULL, *Txx_YpZm_Y=NULL, *Txx_YpZm_Z=NULL;
PREC_GRILLE *Tyy_YpZm_X=NULL, *Tyy_YpZm_Y=NULL, *Tyy_YpZm_Z=NULL;
PREC_GRILLE *Tzz_YpZm_X=NULL, *Tzz_YpZm_Y=NULL, *Tzz_YpZm_Z=NULL;
PREC_GRILLE *Txy_YpZm_X=NULL, *Txy_YpZm_Y=NULL;
PREC_GRILLE *Tyz_YpZm_Y=NULL, *Tyz_YpZm_Z=NULL;
PREC_GRILLE *Tzx_YpZm_Z=NULL, *Tzx_YpZm_X=NULL;

PREC_GRILLE *Vx_YmZp_X=NULL, *Vx_YmZp_Y=NULL, *Vx_YmZp_Z=NULL;
PREC_GRILLE *Vy_YmZp_X=NULL, *Vy_YmZp_Y=NULL, *Vy_YmZp_Z=NULL;
PREC_GRILLE *Vz_YmZp_X=NULL, *Vz_YmZp_Y=NULL, *Vz_YmZp_Z=NULL;
PREC_GRILLE *Txx_YmZp_X=NULL, *Txx_YmZp_Y=NULL, *Txx_YmZp_Z=NULL;
PREC_GRILLE *Tyy_YmZp_X=NULL, *Tyy_YmZp_Y=NULL, *Tyy_YmZp_Z=NULL;
PREC_GRILLE *Tzz_YmZp_X=NULL, *Tzz_YmZp_Y=NULL, *Tzz_YmZp_Z=NULL;
PREC_GRILLE *Txy_YmZp_X=NULL, *Txy_YmZp_Y=NULL;
PREC_GRILLE *Tyz_YmZp_Y=NULL, *Tyz_YmZp_Z=NULL;
PREC_GRILLE *Tzx_YmZp_Z=NULL, *Tzx_YmZp_X=NULL;

PREC_GRILLE *Vx_YmZm_X=NULL, *Vx_YmZm_Y=NULL, *Vx_YmZm_Z=NULL;
PREC_GRILLE *Vy_YmZm_X=NULL, *Vy_YmZm_Y=NULL, *Vy_YmZm_Z=NULL;
PREC_GRILLE *Vz_YmZm_X=NULL, *Vz_YmZm_Y=NULL, *Vz_YmZm_Z=NULL;
PREC_GRILLE *Txx_YmZm_X=NULL, *Txx_YmZm_Y=NULL, *Txx_YmZm_Z=NULL;
PREC_GRILLE *Tyy_YmZm_X=NULL, *Tyy_YmZm_Y=NULL, *Tyy_YmZm_Z=NULL;
PREC_GRILLE *Tzz_YmZm_X=NULL, *Tzz_YmZm_Y=NULL, *Tzz_YmZm_Z=NULL;
PREC_GRILLE *Txy_YmZm_X=NULL, *Txy_YmZm_Y=NULL;
PREC_GRILLE *Tyz_YmZm_Y=NULL, *Tyz_YmZm_Z=NULL;
PREC_GRILLE *Tzx_YmZm_Z=NULL, *Tzx_YmZm_X=NULL;

PREC_GRILLE *Vx_ZpXp_X=NULL, *Vx_ZpXp_Y=NULL, *Vx_ZpXp_Z=NULL;
PREC_GRILLE *Vy_ZpXp_X=NULL, *Vy_ZpXp_Y=NULL, *Vy_ZpXp_Z=NULL;
PREC_GRILLE *Vz_ZpXp_X=NULL, *Vz_ZpXp_Y=NULL, *Vz_ZpXp_Z=NULL;
PREC_GRILLE *Txx_ZpXp_X=NULL, *Txx_ZpXp_Y=NULL, *Txx_ZpXp_Z=NULL;
PREC_GRILLE *Tyy_ZpXp_X=NULL, *Tyy_ZpXp_Y=NULL, *Tyy_ZpXp_Z=NULL;
PREC_GRILLE *Tzz_ZpXp_X=NULL, *Tzz_ZpXp_Y=NULL, *Tzz_ZpXp_Z=NULL;
PREC_GRILLE *Txy_ZpXp_X=NULL, *Txy_ZpXp_Y=NULL;
PREC_GRILLE *Tyz_ZpXp_Y=NULL, *Tyz_ZpXp_Z=NULL;
PREC_GRILLE *Tzx_ZpXp_Z=NULL, *Tzx_ZpXp_X=NULL;

PREC_GRILLE *Vx_ZpXm_X=NULL, *Vx_ZpXm_Y=NULL, *Vx_ZpXm_Z=NULL;
PREC_GRILLE *Vy_ZpXm_X=NULL, *Vy_ZpXm_Y=NULL, *Vy_ZpXm_Z=NULL;
PREC_GRILLE *Vz_ZpXm_X=NULL, *Vz_ZpXm_Y=NULL, *Vz_ZpXm_Z=NULL;
PREC_GRILLE *Txx_ZpXm_X=NULL, *Txx_ZpXm_Y=NULL, *Txx_ZpXm_Z=NULL;
PREC_GRILLE *Tyy_ZpXm_X=NULL, *Tyy_ZpXm_Y=NULL, *Tyy_ZpXm_Z=NULL;
PREC_GRILLE *Tzz_ZpXm_X=NULL, *Tzz_ZpXm_Y=NULL, *Tzz_ZpXm_Z=NULL;
PREC_GRILLE *Txy_ZpXm_X=NULL, *Txy_ZpXm_Y=NULL;
PREC_GRILLE *Tyz_ZpXm_Y=NULL, *Tyz_ZpXm_Z=NULL;
PREC_GRILLE *Tzx_ZpXm_Z=NULL, *Tzx_ZpXm_X=NULL;

PREC_GRILLE *Vx_ZmXp_X=NULL, *Vx_ZmXp_Y=NULL, *Vx_ZmXp_Z=NULL;
PREC_GRILLE *Vy_ZmXp_X=NULL, *Vy_ZmXp_Y=NULL, *Vy_ZmXp_Z=NULL;
PREC_GRILLE *Vz_ZmXp_X=NULL, *Vz_ZmXp_Y=NULL, *Vz_ZmXp_Z=NULL;
PREC_GRILLE *Txx_ZmXp_X=NULL, *Txx_ZmXp_Y=NULL, *Txx_ZmXp_Z=NULL;
PREC_GRILLE *Tyy_ZmXp_X=NULL, *Tyy_ZmXp_Y=NULL, *Tyy_ZmXp_Z=NULL;
PREC_GRILLE *Tzz_ZmXp_X=NULL, *Tzz_ZmXp_Y=NULL, *Tzz_ZmXp_Z=NULL;
PREC_GRILLE *Txy_ZmXp_X=NULL, *Txy_ZmXp_Y=NULL;
PREC_GRILLE *Tyz_ZmXp_Y=NULL, *Tyz_ZmXp_Z=NULL;
PREC_GRILLE *Tzx_ZmXp_Z=NULL, *Tzx_ZmXp_X=NULL;

PREC_GRILLE *Vx_ZmXm_X=NULL, *Vx_ZmXm_Y=NULL, *Vx_ZmXm_Z=NULL;
PREC_GRILLE *Vy_ZmXm_X=NULL, *Vy_ZmXm_Y=NULL, *Vy_ZmXm_Z=NULL;
PREC_GRILLE *Vz_ZmXm_X=NULL, *Vz_ZmXm_Y=NULL, *Vz_ZmXm_Z=NULL;
PREC_GRILLE *Txx_ZmXm_X=NULL, *Txx_ZmXm_Y=NULL, *Txx_ZmXm_Z=NULL;
PREC_GRILLE *Tyy_ZmXm_X=NULL, *Tyy_ZmXm_Y=NULL, *Tyy_ZmXm_Z=NULL;
PREC_GRILLE *Tzz_ZmXm_X=NULL, *Tzz_ZmXm_Y=NULL, *Tzz_ZmXm_Z=NULL;
PREC_GRILLE *Txy_ZmXm_X=NULL, *Txy_ZmXm_Y=NULL;
PREC_GRILLE *Tyz_ZmXm_Y=NULL, *Tyz_ZmXm_Z=NULL;
PREC_GRILLE *Tzx_ZmXm_Z=NULL, *Tzx_ZmXm_X=NULL;

/****************************************************************************/
/*************************** Grilles de Coins PML ***************************/
/****************************************************************************/

PREC_GRILLE *Vx_XpYpZp_X=NULL, *Vx_XpYpZp_Y=NULL, *Vx_XpYpZp_Z=NULL;
PREC_GRILLE *Vy_XpYpZp_X=NULL, *Vy_XpYpZp_Y=NULL, *Vy_XpYpZp_Z=NULL;
PREC_GRILLE *Vz_XpYpZp_X=NULL, *Vz_XpYpZp_Y=NULL, *Vz_XpYpZp_Z=NULL;
PREC_GRILLE *Txx_XpYpZp_X=NULL, *Txx_XpYpZp_Y=NULL, *Txx_XpYpZp_Z=NULL;
PREC_GRILLE *Tyy_XpYpZp_X=NULL, *Tyy_XpYpZp_Y=NULL, *Tyy_XpYpZp_Z=NULL;
PREC_GRILLE *Tzz_XpYpZp_X=NULL, *Tzz_XpYpZp_Y=NULL, *Tzz_XpYpZp_Z=NULL;
PREC_GRILLE *Txy_XpYpZp_X=NULL, *Txy_XpYpZp_Y=NULL;
PREC_GRILLE *Tyz_XpYpZp_Y=NULL, *Tyz_XpYpZp_Z=NULL;
PREC_GRILLE *Tzx_XpYpZp_Z=NULL, *Tzx_XpYpZp_X=NULL;

PREC_GRILLE *Vx_XpYpZm_X=NULL, *Vx_XpYpZm_Y=NULL, *Vx_XpYpZm_Z=NULL;
PREC_GRILLE *Vy_XpYpZm_X=NULL, *Vy_XpYpZm_Y=NULL, *Vy_XpYpZm_Z=NULL;
PREC_GRILLE *Vz_XpYpZm_X=NULL, *Vz_XpYpZm_Y=NULL, *Vz_XpYpZm_Z=NULL;
PREC_GRILLE *Txx_XpYpZm_X=NULL, *Txx_XpYpZm_Y=NULL, *Txx_XpYpZm_Z=NULL;
PREC_GRILLE *Tyy_XpYpZm_X=NULL, *Tyy_XpYpZm_Y=NULL, *Tyy_XpYpZm_Z=NULL;
PREC_GRILLE *Tzz_XpYpZm_X=NULL, *Tzz_XpYpZm_Y=NULL, *Tzz_XpYpZm_Z=NULL;
PREC_GRILLE *Txy_XpYpZm_X=NULL, *Txy_XpYpZm_Y=NULL;
PREC_GRILLE *Tyz_XpYpZm_Y=NULL, *Tyz_XpYpZm_Z=NULL;
PREC_GRILLE *Tzx_XpYpZm_Z=NULL, *Tzx_XpYpZm_X=NULL;

PREC_GRILLE *Vx_XpYmZp_X=NULL, *Vx_XpYmZp_Y=NULL, *Vx_XpYmZp_Z=NULL;
PREC_GRILLE *Vy_XpYmZp_X=NULL, *Vy_XpYmZp_Y=NULL, *Vy_XpYmZp_Z=NULL;
PREC_GRILLE *Vz_XpYmZp_X=NULL, *Vz_XpYmZp_Y=NULL, *Vz_XpYmZp_Z=NULL;
PREC_GRILLE *Txx_XpYmZp_X=NULL, *Txx_XpYmZp_Y=NULL, *Txx_XpYmZp_Z=NULL;
PREC_GRILLE *Tyy_XpYmZp_X=NULL, *Tyy_XpYmZp_Y=NULL, *Tyy_XpYmZp_Z=NULL;
PREC_GRILLE *Tzz_XpYmZp_X=NULL, *Tzz_XpYmZp_Y=NULL, *Tzz_XpYmZp_Z=NULL;
PREC_GRILLE *Txy_XpYmZp_X=NULL, *Txy_XpYmZp_Y=NULL;
PREC_GRILLE *Tyz_XpYmZp_Y=NULL, *Tyz_XpYmZp_Z=NULL;
PREC_GRILLE *Tzx_XpYmZp_Z=NULL, *Tzx_XpYmZp_X=NULL;

PREC_GRILLE *Vx_XpYmZm_X=NULL, *Vx_XpYmZm_Y=NULL, *Vx_XpYmZm_Z=NULL;
PREC_GRILLE *Vy_XpYmZm_X=NULL, *Vy_XpYmZm_Y=NULL, *Vy_XpYmZm_Z=NULL;
PREC_GRILLE *Vz_XpYmZm_X=NULL, *Vz_XpYmZm_Y=NULL, *Vz_XpYmZm_Z=NULL;
PREC_GRILLE *Txx_XpYmZm_X=NULL, *Txx_XpYmZm_Y=NULL, *Txx_XpYmZm_Z=NULL;
PREC_GRILLE *Tyy_XpYmZm_X=NULL, *Tyy_XpYmZm_Y=NULL, *Tyy_XpYmZm_Z=NULL;
PREC_GRILLE *Tzz_XpYmZm_X=NULL, *Tzz_XpYmZm_Y=NULL, *Tzz_XpYmZm_Z=NULL;
PREC_GRILLE *Txy_XpYmZm_X=NULL, *Txy_XpYmZm_Y=NULL;
PREC_GRILLE *Tyz_XpYmZm_Y=NULL, *Tyz_XpYmZm_Z=NULL;
PREC_GRILLE *Tzx_XpYmZm_Z=NULL, *Tzx_XpYmZm_X=NULL;

PREC_GRILLE *Vx_XmYpZp_X=NULL, *Vx_XmYpZp_Y=NULL, *Vx_XmYpZp_Z=NULL;
PREC_GRILLE *Vy_XmYpZp_X=NULL, *Vy_XmYpZp_Y=NULL, *Vy_XmYpZp_Z=NULL;
PREC_GRILLE *Vz_XmYpZp_X=NULL, *Vz_XmYpZp_Y=NULL, *Vz_XmYpZp_Z=NULL;
PREC_GRILLE *Txx_XmYpZp_X=NULL, *Txx_XmYpZp_Y=NULL, *Txx_XmYpZp_Z=NULL;
PREC_GRILLE *Tyy_XmYpZp_X=NULL, *Tyy_XmYpZp_Y=NULL, *Tyy_XmYpZp_Z=NULL;
PREC_GRILLE *Tzz_XmYpZp_X=NULL, *Tzz_XmYpZp_Y=NULL, *Tzz_XmYpZp_Z=NULL;
PREC_GRILLE *Txy_XmYpZp_X=NULL, *Txy_XmYpZp_Y=NULL;
PREC_GRILLE *Tyz_XmYpZp_Y=NULL, *Tyz_XmYpZp_Z=NULL;
PREC_GRILLE *Tzx_XmYpZp_Z=NULL, *Tzx_XmYpZp_X=NULL;

PREC_GRILLE *Vx_XmYpZm_X=NULL, *Vx_XmYpZm_Y=NULL, *Vx_XmYpZm_Z=NULL;
PREC_GRILLE *Vy_XmYpZm_X=NULL, *Vy_XmYpZm_Y=NULL, *Vy_XmYpZm_Z=NULL;
PREC_GRILLE *Vz_XmYpZm_X=NULL, *Vz_XmYpZm_Y=NULL, *Vz_XmYpZm_Z=NULL;
PREC_GRILLE *Txx_XmYpZm_X=NULL, *Txx_XmYpZm_Y=NULL, *Txx_XmYpZm_Z=NULL;
PREC_GRILLE *Tyy_XmYpZm_X=NULL, *Tyy_XmYpZm_Y=NULL, *Tyy_XmYpZm_Z=NULL;
PREC_GRILLE *Tzz_XmYpZm_X=NULL, *Tzz_XmYpZm_Y=NULL, *Tzz_XmYpZm_Z=NULL;
PREC_GRILLE *Txy_XmYpZm_X=NULL, *Txy_XmYpZm_Y=NULL;
PREC_GRILLE *Tyz_XmYpZm_Y=NULL, *Tyz_XmYpZm_Z=NULL;
PREC_GRILLE *Tzx_XmYpZm_Z=NULL, *Tzx_XmYpZm_X=NULL;

PREC_GRILLE *Vx_XmYmZp_X=NULL, *Vx_XmYmZp_Y=NULL, *Vx_XmYmZp_Z=NULL;
PREC_GRILLE *Vy_XmYmZp_X=NULL, *Vy_XmYmZp_Y=NULL, *Vy_XmYmZp_Z=NULL;
PREC_GRILLE *Vz_XmYmZp_X=NULL, *Vz_XmYmZp_Y=NULL, *Vz_XmYmZp_Z=NULL;
PREC_GRILLE *Txx_XmYmZp_X=NULL, *Txx_XmYmZp_Y=NULL, *Txx_XmYmZp_Z=NULL;
PREC_GRILLE *Tyy_XmYmZp_X=NULL, *Tyy_XmYmZp_Y=NULL, *Tyy_XmYmZp_Z=NULL;
PREC_GRILLE *Tzz_XmYmZp_X=NULL, *Tzz_XmYmZp_Y=NULL, *Tzz_XmYmZp_Z=NULL;
PREC_GRILLE *Txy_XmYmZp_X=NULL, *Txy_XmYmZp_Y=NULL;
PREC_GRILLE *Tyz_XmYmZp_Y=NULL, *Tyz_XmYmZp_Z=NULL;
PREC_GRILLE *Tzx_XmYmZp_Z=NULL, *Tzx_XmYmZp_X=NULL;

PREC_GRILLE *Vx_XmYmZm_X=NULL, *Vx_XmYmZm_Y=NULL, *Vx_XmYmZm_Z=NULL;
PREC_GRILLE *Vy_XmYmZm_X=NULL, *Vy_XmYmZm_Y=NULL, *Vy_XmYmZm_Z=NULL;
PREC_GRILLE *Vz_XmYmZm_X=NULL, *Vz_XmYmZm_Y=NULL, *Vz_XmYmZm_Z=NULL;
PREC_GRILLE *Txx_XmYmZm_X=NULL, *Txx_XmYmZm_Y=NULL, *Txx_XmYmZm_Z=NULL;
PREC_GRILLE *Tyy_XmYmZm_X=NULL, *Tyy_XmYmZm_Y=NULL, *Tyy_XmYmZm_Z=NULL;
PREC_GRILLE *Tzz_XmYmZm_X=NULL, *Tzz_XmYmZm_Y=NULL, *Tzz_XmYmZm_Z=NULL;
PREC_GRILLE *Txy_XmYmZm_X=NULL, *Txy_XmYmZm_Y=NULL;
PREC_GRILLE *Tyz_XmYmZm_Y=NULL, *Tyz_XmYmZm_Z=NULL;
PREC_GRILLE *Tzx_XmYmZm_Z=NULL, *Tzx_XmYmZm_X=NULL;

/****************************************************************************/
/*************************** Grilles Tampon *********************************/
/****************************************************************************/

/****************************************************************************/
/*************************** Tampon Faces PML *******************************/
/****************************************************************************/

PREC_GRILLE *Vi_BufferFaceBlocI=NULL;
PREC_GRILLE *Tij_BufferFaceBlocI=NULL;
PREC_GRILLE *Tki_BufferFaceBlocI=NULL;

PREC_GRILLE *Vi_BufferFaceAreteJp=NULL;
PREC_GRILLE *Vi_BufferFaceAreteJm=NULL;
PREC_GRILLE *Vk_BufferFaceAreteJp=NULL;
PREC_GRILLE *Vk_BufferFaceAreteJm=NULL;
PREC_GRILLE *Tki_BufferFaceAreteJp=NULL;
PREC_GRILLE *Tki_BufferFaceAreteJm=NULL;
PREC_GRILLE *Tjj_BufferFaceAreteJp=NULL;
PREC_GRILLE *Tjj_BufferFaceAreteJm=NULL;

PREC_GRILLE *Vi_BufferFaceAreteKp=NULL;
PREC_GRILLE *Vi_BufferFaceAreteKm=NULL;
PREC_GRILLE *Vj_BufferFaceAreteKp=NULL;
PREC_GRILLE *Vj_BufferFaceAreteKm=NULL;
PREC_GRILLE *Tij_BufferFaceAreteKp=NULL;
PREC_GRILLE *Tij_BufferFaceAreteKm=NULL;
PREC_GRILLE *Tkk_BufferFaceAreteKp=NULL;
PREC_GRILLE *Tkk_BufferFaceAreteKm=NULL;

/****************************************************************************/
/*************************** Tampon Aretes PML ******************************/
/****************************************************************************/

PREC_GRILLE *Vj_BufferAreteFaceI=NULL;
PREC_GRILLE *Tjk_BufferAreteFaceI=NULL;
PREC_GRILLE *Tij_BufferAreteFaceI=NULL;

PREC_GRILLE *Vi_BufferAreteFaceJ=NULL;
PREC_GRILLE *Tij_BufferAreteFaceJ=NULL;
PREC_GRILLE *Tki_BufferAreteFaceJ=NULL;

PREC_GRILLE *Vi_BufferAreteCoinKp=NULL;
PREC_GRILLE *Vi_BufferAreteCoinKm=NULL;
PREC_GRILLE *Vj_BufferAreteCoinKp=NULL;
PREC_GRILLE *Vj_BufferAreteCoinKm=NULL;
PREC_GRILLE *Tij_BufferAreteCoinKp=NULL;
PREC_GRILLE *Tij_BufferAreteCoinKm=NULL;
PREC_GRILLE *Tkk_BufferAreteCoinKp=NULL;
PREC_GRILLE *Tkk_BufferAreteCoinKm=NULL;

/****************************************************************************/
/*************************** Tampon Coins PML *******************************/
/****************************************************************************/

PREC_GRILLE *Vi_BufferCoinAreteI=NULL;
PREC_GRILLE *Tij_BufferCoinAreteI=NULL;
PREC_GRILLE *Tki_BufferCoinAreteI=NULL;

PREC_GRILLE *Vj_BufferCoinAreteJ=NULL;
PREC_GRILLE *Tij_BufferCoinAreteJ=NULL;
PREC_GRILLE *Tjk_BufferCoinAreteJ=NULL;

PREC_GRILLE *Vk_BufferCoinAreteK=NULL;
PREC_GRILLE *Tjk_BufferCoinAreteK=NULL;
PREC_GRILLE *Tki_BufferCoinAreteK=NULL;

/****************************************************************************/
/********************* Tampon physiquement allous **************************/
/****************************************************************************/

PREC_CARTE  *Carte_Tampon=NULL;

PREC_GRILLE *Buffer1AireMax=NULL;
PREC_GRILLE *Buffer2AireMax=NULL;

PREC_GRILLE *Buffer01AireIntermediaire=NULL;
PREC_GRILLE *Buffer02AireIntermediaire=NULL;
PREC_GRILLE *Buffer03AireIntermediaire=NULL;
PREC_GRILLE *Buffer04AireIntermediaire=NULL;
PREC_GRILLE *Buffer05AireIntermediaire=NULL;
PREC_GRILLE *Buffer06AireIntermediaire=NULL;
PREC_GRILLE *Buffer07AireIntermediaire=NULL;
PREC_GRILLE *Buffer08AireIntermediaire=NULL;


/****************************************************************************/
/*************************** Carte du milieu ********************************/
/****************************************************************************/

PREC_CARTE *Carte=NULL;

/****************************************************************************/
/*************************** Parametres du milieu ***************************/
/****************************************************************************/

double *TableLegerete=NULL;
double *TableC11=NULL;
double *TableC22=NULL;
double *TableC33=NULL;
double *TableC12=NULL;
double *TableC23=NULL;
double *TableC31=NULL;
double *TableC44=NULL;
double *TableC55=NULL;
double *TableC66=NULL;
double *TableQModel = NULL ;

double *AttenuationPML=NULL;

double *TableCii=NULL;
double *TableCjj=NULL;
double *TableCkk=NULL;
double *TableCij=NULL;
double *TableCjk=NULL;
double *TableCki=NULL;
double *TableCjkjk=NULL;
double *TableCkiki=NULL;
double *TableCijij=NULL;

/****************************************************************************/
/*************************** Paramtres gneraux ****************************/
/****************************************************************************/

double H, Duree, Vmax, VmaxPML, DeltaT,CoeffDeltaT;
double DeltaTsurH;
int IndiceTempsMax,IndiceTemps;
double PeriodBloc;
double PeriodRecepteurs;
double PeriodPlan;
//double FreqBloc; //to clear
//double FreqRecepteurs;//to clear
//double FreqPlan;//to clear

int IndiceTempsBloc;
int IndiceTempsRecepteurs;
int IndiceTempsPlan;
int IndiceTempsAffichageTempsRestant ;
int NumeroBloc;
int NumeroPlan;

int TypeAbsorption ;
double CoeffPML;
char Repertoire[500];

int IsSkipFileCreated = 0;
int IsDoneFileCreated = 0;

time_t TempsDebut,TempsCourant;
double TempsRestant;

int RcvDwnSmplng;
int SourceType;

int ConditionFaceXp, ConditionFaceXm;
int ConditionFaceYp, ConditionFaceYm;
int ConditionFaceZp, ConditionFaceZm;

int SnapshotV,SnapshotEc,SnapshotVx,SnapshotVy,SnapshotVz;
int SnapshotUx,SnapshotUy,SnapshotUz;
int SnapshotTxx,SnapshotTyy,SnapshotTzz;
int SnapshotTxy,SnapshotTyz,SnapshotTzx;

int NumberSelectedSnapshotsBlocs=0;
int NumberSelectedSnapshotsPlans=0;


int *SnapshotsBlocsTimeSelection=NULL;
int *SnapshotsPlansTimeSelection=NULL;


struct SAUVEGARDE_PLAN
{
	int NbPlan;
	char *TypePlan;
	int *CotePlan;
};

struct SAUVEGARDE_PLAN ListePlanV,ListePlanEc,ListePlanVx,ListePlanVy,ListePlanVz;
struct SAUVEGARDE_PLAN ListePlanTxx,ListePlanTyy,ListePlanTzz;
struct SAUVEGARDE_PLAN ListePlanTxy,ListePlanTyz,ListePlanTzx;


/****************************************************************************/
/*************************** Gestion des transducteurs **********************/
/****************************************************************************/

struct MATRICE_EMISSION
{
	char PlanI;
	int XMat,YMat,ZMat;
	int NbElementsJ,PitchJ,LargeurJ,ApodisationJ;
	int NbElementsK,PitchK,LargeurK,ApodisationK;
	int FocalisationJ,FocalisationK;
	double Focale,DirectionJ,DirectionK;
	double VitesseMilieuEmission;
	int TypeSignal;
	char NomSignal[200];
	double Freq,T0,Bandwidth;
	double *Signal;
	int DurationPt; /*20050930*/
};

struct MATRICE_RECEPTION
{
	char Nom[200];
	char PlanI;
    int ActiveMedium;
    int DurationPt;
	int XMat,YMat,ZMat;
	int NbElementsJ,PitchJ,LargeurJ;
	int NbElementsK,PitchK,LargeurK;
	double *Signaux;
};

int NbMatricesEmissionTxx;
struct MATRICE_EMISSION *EmissionTxx=NULL;
int NbMatricesEmissionTyy;
struct MATRICE_EMISSION *EmissionTyy=NULL;
int NbMatricesEmissionTzz;
struct MATRICE_EMISSION *EmissionTzz=NULL;
int NbMatricesEmissionTxy;
struct MATRICE_EMISSION *EmissionTxy=NULL;
int NbMatricesEmissionTyz;
struct MATRICE_EMISSION *EmissionTyz=NULL;
int NbMatricesEmissionTzx;
struct MATRICE_EMISSION *EmissionTzx=NULL;
int NbMatricesEmissionVx;
struct MATRICE_EMISSION *EmissionVx=NULL;
int NbMatricesEmissionVy;
struct MATRICE_EMISSION *EmissionVy=NULL;
int NbMatricesEmissionVz;
struct MATRICE_EMISSION *EmissionVz=NULL;

int NbMatricesReceptionTxx;
struct MATRICE_RECEPTION *ReceptionTxx=NULL;
int NbMatricesReceptionTyy;
struct MATRICE_RECEPTION *ReceptionTyy=NULL;
int NbMatricesReceptionTzz;
struct MATRICE_RECEPTION *ReceptionTzz=NULL;
int NbMatricesReceptionTxy;
struct MATRICE_RECEPTION *ReceptionTxy=NULL;
int NbMatricesReceptionTyz;
struct MATRICE_RECEPTION *ReceptionTyz=NULL;
int NbMatricesReceptionTzx;
struct MATRICE_RECEPTION *ReceptionTzx=NULL;
int NbMatricesReceptionVx;
struct MATRICE_RECEPTION *ReceptionVx=NULL;
int NbMatricesReceptionVy;
struct MATRICE_RECEPTION *ReceptionVy=NULL;
int NbMatricesReceptionVz;
struct MATRICE_RECEPTION *ReceptionVz=NULL;


int NbMatricesSourceFilesTxx;
struct MATRICE_RECEPTION *MatricesSourceFilesTxx= NULL;
int NbMatricesSourceFilesTyy;
struct MATRICE_RECEPTION *MatricesSourceFilesTyy= NULL;
int NbMatricesSourceFilesTzz;
struct MATRICE_RECEPTION *MatricesSourceFilesTzz= NULL;
int NbMatricesSourceFilesTxy;
struct MATRICE_RECEPTION *MatricesSourceFilesTxy= NULL;
int NbMatricesSourceFilesTyz;
struct MATRICE_RECEPTION *MatricesSourceFilesTyz= NULL;
int NbMatricesSourceFilesTzx;
struct MATRICE_RECEPTION *MatricesSourceFilesTzx= NULL;
int NbMatricesSourceFilesVx;
struct MATRICE_RECEPTION *MatricesSourceFilesVx= NULL;
int NbMatricesSourceFilesVy;
struct MATRICE_RECEPTION *MatricesSourceFilesVy= NULL;
int NbMatricesSourceFilesVz;
struct MATRICE_RECEPTION *MatricesSourceFilesVz= NULL;

/***************************************************************************/
/***************************************************************************/
/*********************** Prototype des fonctions ***************************/
/***************************************************************************/
/***************************************************************************/

void AllocationGrilles(void);
void LiberationMemoire(void);
void CalculVitesses(void);
void ComputeDisplacement(void);
void CalculContraintes(void);

void GenerationSignal(int TypeSignal, double Freq, double T0, double Bandwidth,double *Signal);
void LectureSignal(struct MATRICE_EMISSION *MatriceCourante,int NbPtsSignal);
void SauvegardeSnapshotBlocs(int numero);
void SauvegardeSnapshotPlans(int numero);

void AffichageEndTime(void);
void AffichageStartTime(void);
void AffichageTempsRestant(void);
void AffichageDureeSimul(void);

void SourcesContraintes(void);
void SourcesVitesses(void);
void SauvegardeRecepteurs(void);
void LectureParametres(void);
double MaxAbsSignal(double *,int);
int DeuxiemeMax(int, int, int);
void LectureConditionsInitiales(char *NomFichierCondIni,PREC_GRILLE *GrilleLue,int DimX, int DimY, int DimZ);


/***************************************************************************/
/**************   Gestion des Transducteurs ********************************/
/***************************************************************************/

void LectureParametresMatriceEmission(FILE *Fich,
									  char *LigneCourante,
									  struct MATRICE_EMISSION *MatriceCourante);
int ValiditeMatriceEmission(struct MATRICE_EMISSION *MatriceCourante,int LimX,int LimY,int LimZ);
void ActivationMatriceEmission(PREC_GRILLE *GrilleCourante,
							   struct MATRICE_EMISSION *MatriceCourante,
							   int DimX, int DimY, int DimZ);
void ActivationMatriceSourceFile(PREC_GRILLE *GrilleCourante,
                                 struct MATRICE_RECEPTION *MatriceCourante,
                                 int DimX,int DimY, int DimZ);

void LectureParametresMatriceReception(FILE *Fich,
									  char *LigneCourante,
									  struct MATRICE_RECEPTION *MatriceCourante);
void LectureParametresMatriceSourceFile(FILE *Fich,
									  char *LigneCourante,
									  struct MATRICE_RECEPTION *MatriceCourante);
int ValiditeMatriceReception(struct MATRICE_RECEPTION *MatriceCourante,int LimX,int LimY,int LimZ);
void EnregistrementMatriceReception(PREC_GRILLE *GrilleCourante,
							   struct MATRICE_RECEPTION *MatriceCourante,int DimX,int DimY,int DimZ);
void MAJMatricesReception(void);

/***************************************************************************/
/**************   Gestion des tampons **************************************/
/***************************************************************************/

void AdressageBuffer(void);
void MiseAJourContraintesTamponFacePML(const char *TypeFace);
void MiseAJourVitessesTamponFacePML(const char *TypeFace);
void MiseAJourContraintesTamponAretePML(const char *TypeArete);
void MiseAJourVitessesTamponAretePML(const char *TypeArete);
void MiseAJourContraintesTamponCoinPML(const char *TypeCoin);
void MiseAJourVitessesTamponCoinPML(const char *TypeCoin);
void ReMiseAZeroTampons(void);

/***************************************************************************/
/**************  Fonctions de CALCUL ***************************************/
/***************************************************************************/

void CalculBordsVitesses(void);
void CalculBordsContraintes(void);
void CalculPMLFaceContraintes(PREC_GRILLE *Vi_I,PREC_GRILLE *Vi_JK,
															PREC_GRILLE *Vj_I,PREC_GRILLE *Vj_JK,
															PREC_GRILLE *Vk_I,PREC_GRILLE *Vk_JK,
															PREC_GRILLE *Tii_I,PREC_GRILLE *Tii_JK,
															PREC_GRILLE *Tjj_I,PREC_GRILLE *Tjj_JK,
															PREC_GRILLE *Tkk_I,PREC_GRILLE *Tkk_JK,
															PREC_GRILLE *Tij_I,PREC_GRILLE *Tij_JK,
															PREC_GRILLE *Tki_I,PREC_GRILLE *Tki_JK,
															PREC_GRILLE *Tjk,
															int J, int K,
															const char *TypeFace);
void CalculPMLFaceVitesses(PREC_GRILLE *Vi_I,PREC_GRILLE *Vi_JK,
													 PREC_GRILLE *Vj_I,PREC_GRILLE *Vj_JK,
													 PREC_GRILLE *Vk_I,PREC_GRILLE *Vk_JK,
													 PREC_GRILLE *Tii_I,PREC_GRILLE *Tii_JK,
													 PREC_GRILLE *Tjj_I,PREC_GRILLE *Tjj_JK,
													 PREC_GRILLE *Tkk_I,PREC_GRILLE *Tkk_JK,
													 PREC_GRILLE *Tij_I,PREC_GRILLE *Tij_JK,
													 PREC_GRILLE *Tki_I,PREC_GRILLE *Tki_JK,
													 PREC_GRILLE *Tjk,
													 int J, int K,
													 const char *TypeFace);
void CalculPMLAreteContraintes(PREC_GRILLE *Vi_I,PREC_GRILLE *Vi_J,PREC_GRILLE *Vi_K,
															 PREC_GRILLE *Vj_I,PREC_GRILLE *Vj_J,PREC_GRILLE *Vj_K,
															 PREC_GRILLE *Vk_I,PREC_GRILLE *Vk_J,PREC_GRILLE *Vk_K,
															 PREC_GRILLE *Tii_I,PREC_GRILLE *Tii_J,PREC_GRILLE *Tii_K,
															 PREC_GRILLE *Tjj_I,PREC_GRILLE *Tjj_J,PREC_GRILLE *Tjj_K,
															 PREC_GRILLE *Tkk_I,PREC_GRILLE *Tkk_J,PREC_GRILLE *Tkk_K,
															 PREC_GRILLE *Tij_I,PREC_GRILLE *Tij_J,
															 PREC_GRILLE *Tjk_J,PREC_GRILLE *Tjk_K,
															 PREC_GRILLE *Tki_K,PREC_GRILLE *Tki_I,
															 int K,
		 													 const char *TypeArete);
void CalculPMLAreteVitesses(PREC_GRILLE *Vi_I,PREC_GRILLE *Vi_J,PREC_GRILLE *Vi_K,
 													  PREC_GRILLE *Vj_I,PREC_GRILLE *Vj_J,PREC_GRILLE *Vj_K,
 													  PREC_GRILLE *Vk_I,PREC_GRILLE *Vk_J,PREC_GRILLE *Vk_K,
													  PREC_GRILLE *Tii_I,PREC_GRILLE *Tii_J,PREC_GRILLE *Tii_K,
													  PREC_GRILLE *Tjj_I,PREC_GRILLE *Tjj_J,PREC_GRILLE *Tjj_K,
													  PREC_GRILLE *Tkk_I,PREC_GRILLE *Tkk_J,PREC_GRILLE *Tkk_K,
													  PREC_GRILLE *Tij_I,PREC_GRILLE *Tij_J,
													  PREC_GRILLE *Tjk_J,PREC_GRILLE *Tjk_K,
													  PREC_GRILLE *Tki_K,PREC_GRILLE *Tki_I,
													  int K,
 													  const char *TypeArete);
void CalculPMLCoinVitesses(PREC_GRILLE *Vi_I,PREC_GRILLE *Vi_J,PREC_GRILLE *Vi_K,
 													  PREC_GRILLE *Vj_I,PREC_GRILLE *Vj_J,PREC_GRILLE *Vj_K,
 													  PREC_GRILLE *Vk_I,PREC_GRILLE *Vk_J,PREC_GRILLE *Vk_K,
													  PREC_GRILLE *Tii_I,PREC_GRILLE *Tii_J,PREC_GRILLE *Tii_K,
													  PREC_GRILLE *Tjj_I,PREC_GRILLE *Tjj_J,PREC_GRILLE *Tjj_K,
													  PREC_GRILLE *Tkk_I,PREC_GRILLE *Tkk_J,PREC_GRILLE *Tkk_K,
													  PREC_GRILLE *Tij_I,PREC_GRILLE *Tij_J,
													  PREC_GRILLE *Tjk_J,PREC_GRILLE *Tjk_K,
													  PREC_GRILLE *Tki_K,PREC_GRILLE *Tki_I,
 													  const char *TypeCoin);
void CalculPMLCoinContraintes(PREC_GRILLE *Vi_I,PREC_GRILLE *Vi_J,PREC_GRILLE *Vi_K,
 													  PREC_GRILLE *Vj_I,PREC_GRILLE *Vj_J,PREC_GRILLE *Vj_K,
 													  PREC_GRILLE *Vk_I,PREC_GRILLE *Vk_J,PREC_GRILLE *Vk_K,
													  PREC_GRILLE *Tii_I,PREC_GRILLE *Tii_J,PREC_GRILLE *Tii_K,
													  PREC_GRILLE *Tjj_I,PREC_GRILLE *Tjj_J,PREC_GRILLE *Tjj_K,
													  PREC_GRILLE *Tkk_I,PREC_GRILLE *Tkk_J,PREC_GRILLE *Tkk_K,
													  PREC_GRILLE *Tij_I,PREC_GRILLE *Tij_J,
													  PREC_GRILLE *Tjk_J,PREC_GRILLE *Tjk_K,
													  PREC_GRILLE *Tki_K,PREC_GRILLE *Tki_I,
 													  const char *TypeCoin);

/***************************************************************************/
/***************************************************************************/
/***************************************************************************/

